<script>
import back from '@/plugins/axios.js';
import { started_state } from '@/plugins/store.js'
import { onDestroy } from 'svelte';
import { goto } from '$app/navigation';

export let text;
let checkbox;
let fetched = true;
let start;
let done;
let remaining = {
    days: 0,
    hours: 0,
    minutes: 0,
    seconds: 0
}

back.get("/website/dates/start")
    .then(response => {
        fetched = true;
        start = response.data.start_date;
        // Manually parse start using the format YYYY-MM-DDTHH:MM:SS+HH:00
        let year = parseInt(start.substring(0, 4))
        let month = parseInt(start.substring(5, 7))
        let day = parseInt(start.substring(8, 10))
        let hour = parseInt(start.substring(11, 13))
        let minute = parseInt(start.substring(14, 16))
        let second = parseInt(start.substring(17, 19))
        let utcsign = start.substring(19, 20)
        let utchour = parseInt(start.substring(20, 22))
        let utcminute = parseInt(start.substring(23, 25))

        if (utcsign === "-") {
            hour += utchour
            minute += utcminute
        } else {
            hour -= utchour
            minute -= utcminute
        }
        start = Date.UTC(year, month - 1, day, hour, minute, second)

        let interval = setInterval(() => {
            let now = new Date()
            let year = now.getUTCFullYear()
            let month = now.getUTCMonth()
            let day = now.getUTCDate()
            let hour = now.getUTCHours()
            let minute = now.getUTCMinutes()
            let second = now.getUTCSeconds()
            now = Date.UTC(year, month, day, hour, minute, second)

            let diff = start - now
            if (diff <= 0) {
                done = true
                return
            }
            // modify remaining using ints
            remaining.days = Math.floor(diff / 1000 / 60 / 60 / 24)
            diff -= remaining.days * 1000 * 60 * 60 * 24
            remaining.hours = Math.floor(diff / 1000 / 60 / 60)
            diff -= remaining.hours * 1000 * 60 * 60
            remaining.minutes = Math.floor(diff / 1000 / 60)
            diff -= remaining.minutes * 1000 * 60
            remaining.seconds = Math.floor(diff / 1000)

            if (remaining.seconds <= 2 && remaining.minutes == 0 && remaining.hours == 0 && remaining.days == 0) {
                try {
                    checkbox.checked = true;
                } catch (error) {
                    console.log(error)
                }   
                // Wait 3 to 10 seconds before loading everything
                setTimeout(() => {
                    back.get('/website/is_started')
                        .then(response => {
                        switch (response.data.status) {
                            case 'NOT_STARTED':
                            started_state.set(1);
                            break;
                            case 'STARTED':
                            started_state.set(2);
                            break;
                            case 'ENDED':
                            started_state.set(3);
                            break;
                            default:
                            started_state.set(4);
                            break;
                        }
                        })
                        .catch(error => {
                            started_state.set(4);
                        });
                        // Close the modal
                        try {
                            checkbox.checked = false;
                        } catch (error) {
                            console.log(error)
                        }
                        // Get the first streamer id
                        back.get('/streamers/')
                            .then(response => {
                                let streamers = response.data;
                                if (streamers.length > 0) {
                                    goto(`/stream/${streamers[0].id}`)
                                } else {
                                    goto('/')
                                }
                            })
                            .catch(error => {
                                console.log(error);
                            });
                }, Math.floor(Math.random() * 7000) + 3000)
            }
        }, 1000)
        onDestroy(() => {
            clearInterval(interval)
        })
    })
    .catch(error => {
        // console.log(error);
    });
</script>

<!-- The button to open modal -->
<input bind:this={checkbox} type="checkbox" id="my-modal-6" class="modal-toggle" />
<div class="modal modal-bottom sm:modal-middle">
  <div class="modal-box">
    <h3 class="font-bold text-2xl">Début de l'évènement</h3>
    <div class="py-4 text-slate-500">
        <p class="text-md">L'évènement va bientôt démarrer !</p>
        <p class="text-md">
            Pour éviter de casser tout le site, veuillez patienter un petit peu sans rafraîchir la page, nous nous occupons de tout !
        </p>
    </div>
  </div>
</div>

<div class="grid grid-flow-row md:grid-flow-col text-center auto-cols-max">
    <span class="mr-3">{text}</span>
    <span class="">
    {#if fetched}
        {#if !done}
            <span class="countdown font-mono text-xl mt-1">
                <span style="--value:{remaining.days};"></span>
            </span>
            <span class="text-xl font-mono">jour(s)</span>
            <span class="countdown font-mono text-xl mt-1">
                <span style="--value:{remaining.hours};"></span>
            </span>
            <span class="text-xl font-mono">h</span>
            <span class="countdown font-mono text-xl mt-1">
                <span style="--value:{remaining.minutes};"></span>
            </span>
            <span class="text-xl font-mono">m</span>
            <span class="countdown font-mono text-xl mt-1">
                <span style="--value:{remaining.seconds};"></span>
            </span>
            <span class="text-xl font-mono">s</span>
        {:else}
            <h2>Il arrive !</h2>
        {/if}
    {/if}
    </span>
</div>  